示例
参考文档
API 文档
更多
立即试用
示例
示例
表格(Grid)
多行网络(MultiRow)
交易单(Transfer Slip)
基础(Basis)
全球化(Globalization)
格式(Formatting)
解析分析(Parsing)
可定制化(Customization)
字符串模板 ES6(Template Literals)
字符串模板 Wijmo(Template Strings)
多元化(Pluralization)
集合视图(CollectionView)
概览(Overview)
数据加载(Loading Data)
从客户端(from Client)
从服务端(from Server)
加载 JSON 中的日期(Loading JSON Dates)
结合进度指示(Spinners)
创建视图(Creating Views)
当前记录(Current)
排序(Sorting)
概览(Overview)
结合语言特性(International Sort)
稳定排序(Stable Sort)
筛选(Filtering)
概览(Overview)
链接(Chaining)
分组(Grouping)
概览(Overview)
自定义分组(Custom Groups)
分页(Paging)
编辑视图(Editing Views)
编辑(Editing)
添加/删除(Adding/Removing Items)
跟踪修改(Tracking Changes)
验证(Validation)
文档打印(PrintDocument)
剪贴板(Clipboard)
提示(Tooltips)
颜色(Color)
字形(Glyphs)
HTTP请求(HttpRequest)
动画(Animate)
弹出框(ShowPopup)
表格(Grid)
概览(Overview)
数据绑定(Data-binding)
基础(Basics (CollectionView))
OData API(OData API)
虚模式 OData(Virtual OData)
无限滚动(Infinite Scrolling)
非绑定表格(Unbound Grid)
列(Columns)
列宽(Column Width)
数据映射(DataMaps)
列选择器(Column Picker)
顺序重排(Reordering)
列宽调整(Resizing)
冻结(Freezing)
隐形列头(Sticky Headers)
列集合(Collections)
行(Rows)
添加/删除(Adding and Removing)
行高(Row Height)
冻结(Freezing)
行集合(Collections)
明细行(Row Detail)
自定义单元格(Custom Cells)
条件样式(Conditional Styling)
单元格备注(Cell Notes)
动态更新(Dynamic Updates)
迷你图(Sparklines)
自定义编辑器(Custom Editors)
分页/滚动(Paging / Scrolling)
浏览器端分页(Client-side Paging)
服务器端分页(Server-side Paging)
虚模式滚动(Scroll Virtualization)
隐藏滚动条(No Scrollbars)
快速滚动(Fast Scroller)
滚动和可视范围(Scrolling and ViewRange)
排序(Sorting)
概览(Overview)
按需排序(On-demand)
多列排序(Multi-column sorting)
编辑(Editing)
概览(Overview)
快速编辑(Quick Editing)
只读(Read-only)
校验(Validation)
数据集合校验(CollectionView Validation)
事件(Editing Events)
持续编辑模式(Always Editing)
行内编辑(Inline Editing)
编辑框弹出(Popup Editors)
自定义编辑器(Custom Editors)
输入法控制(IME)
选择(Selection)
概览(Overview)
多选(Multiple Selection)
复选框选择(Checkbox Selection)
查找(Searching)
选中框(Marquee)
焦点(Focus)
分组(Grouping)
基本(Groups)
分组面板(GroupPanel)
多级分组(Aggregation)
基本(Aggregate group)
数据行上方(Above the data)
数据行下方(Below the data)
自定义(Custom aggregation)
合并(Merging)
单元格合并(Cell Merging)
列头、行头合并(Header Merging)
自定义合并(Custom Merging)
限制合并(Restricted Merging)
筛选/查找(Filtering / Searching)
筛选(Filter)
类 Excel 筛选(Excel-like Filter)
概览(Overview)
自定义筛选类型(Custom Filter Type)
自定义筛选图标(Custom Filter Icons)
自定义筛选运算符(Custom Filter Operators)
优化加速(Optimizations)
服务端筛选(Server-side)
多层分级数据(Hierarchical Data)
树(TreeGrid)
子项目(Child Items)
可编辑的树(Editable TreeGrid)
非绑定模式(Unbound TreeGrid)
延迟加载(Lazy Loading)
XML 绑定(Binding to XML)
主从表(Master-Detail)
分离(Separate Grid)
内嵌表格(Nested Grid (RowDetail))
多行网络(MultiRow)
布局定义(Layout Definition)
可折叠的列头(Collapsible Column Headers)
格式化记录、分组、单元格(Styling Records, Groups, and Cells)
分组(Grouping)
筛选(Filtering)
行列冻结(Row And Column Freezing)
分页(Paging)
添加或删除记录(Adding and Deleting Records)
交易单(Transfer Slip)
订单条(Orders Slip)
订单详情(Order Detail)
购买单(Purchase Slip)
订单管理(Order Management)
销售单(Sales Slip)
电子表格(FlexSheet)
非绑定模式(Unbound)
绑定模式(Bound)
排序(Sorting)
筛选(Filtering)
格式化单元格(Formatting Cells)
多列/行头(Multiple Headers)
单元格合并(Cell Merging)
拖拽(Drag and Drop)
冻结(Frozen Cells)
公式(Formulas)
自定义函数(Custom Function)
表格(Table)
Excel 导入导出(Excel Import Export)
导入、导出、打印(Import / Export / Print)
Excel (Excel)
异步(Async)
PDF (PDF)
导出文件(Export to file)
导出 PdfDocument(Export to PdfDocument)
自定义字体(Custom fonts)
费用报告(Expense report)
费用分析报告(Expense analysis report)
自定义单元格内容(Custom cell content)
自定义单元格渲染(Customize cell rendering)
绘制单元格(Drawing cells manually)
高亮单元格(Highlight invalid cells)
Web Workers(Web Workers)
打印(Print)
事件(Events)
鼠标(Mouse)
键盘(Keyboard)
选择(Selection)
编辑(Editing)
调整(Resizing)
重排(Reordering)
拖拽(Drag and Drop)
无障碍扩展(Accessibility Extender)
剪贴板(Clipboard)
调整大小(Sizing)
概览(Overview)
通过鼠标调整(Sizing with Mouse)
自动调整行(Auto-size Rows)
自动调整行(异步)(Auto-size Rows Async)
自动调整列(Auto-size Columns)
延迟调整(Deferred Resizing)
样式(Styling)
行(Rows)
概览(Overview)
行高(Row Heights)
保留行高(Preserve Row Heights)
列(Columns)
垂直对齐(Vertical Alignment)
悬停(Hover)
响应式(Responsive)
动画(Animation)
持久化(Persisting State)
图表(Chart)
概览(Overview)
销售 Dashboard (Sales Dashboard)
柱(条)形图(Bar Charts)
基本柱形图(Basic Column Chart)
堆积条形图(Stacked Bar)
负值(Column With Negative Values)
数据标签(Column With Data Label)
范围(Range Bar)
组合(Bar With Line)
轴范围(Column With Axis Range)
误差线Column With Error Bars)
向下钻取(Column With Drill-down)
线、面积图(Line & Area Charts)
基本线图(Basic Line Chart)
基本面积图(Basic Area Chart)
带标记的堆积线(Stacked Line with LineMarker)
100% 堆积表面(Stacked 100% Area)
标记(Spline with Symbols)
带注释的区域(Area with Annotations)
差距线(Line with Gaps)
范围选择(Range Selection)
汇总日期系列(Aggregate Date Series)
动态折线图(Dynamic Line Chart)
对数轴(Logarithmic Axis)
自定义线段(Custom Line Segments)
自定义函数(Custom Function)
范围区域(Range Area)
散点、气泡图(Scatter & Bubble Charts)
XY 散点图(XY Scatter Plot)
带条件格式的散点图(Scatter with Conditional Formatting)
带有趋势线的散点图(Scatter with Trendline)
气泡图(Bubble chart)
带区域的气泡(Bubble with Zones)
散点象限(Scatter Quadrant)
选择框(Select Box)
动画(Bubble with Animation)
饼、旭日图(Pie & Sunburst Charts)
基本饼图(Basic Pie Chart)
带标签的圆环图(Donut Chart with Labels)
动画(Pie Animation)
选择切片(Selectable Slices)
渐变填充(Pie with Gradient Fill)
旭日图(Sunburst)
周期性的旭日图(PeriodicSunburst)
多饼图(Multiple Pie Charts)
树形图(Treemap)
分组树图(Grouped TreeMap)
深度(TreeMap Depth)
水平和垂直(Horizontal & Vertical Treemap)
极地、雷达图(Polar & Radar Charts)
基本雷达图(Basic Radar Chart)
填充雷达图(Radar Filled Chart)
基本极地图(BasicPolarChart)
金融图表(Financial Charts)
烛台图(Candlestick Chart)
HighLowOpenClose Chart
Heikin-Ashi Chart
Line Break Chart
Renko
Kagi
Volume Charts
Financial Indicators
Financial Overlays
Event Annotations
Fibonacci Tools
特殊图表 (Special Charts)
Box & Whisker
ErrorBars
漏斗图 (Funnel Chart)
矩形漏斗 (Funnel Rectangle)
甘特图 (Gantt)
Repeating Tasks
帕累托图 (Pareto)
瀑布图 (Waterfall)
特色功能(Chart Features)
报警区 (Alarm Zones)
动画 (Animation)
标记 (Annotations)
轴原点和位置 (Axis Origin & Position)
条件格式 (Conditional Formatting)
数据标签 (Data Labels)
可编辑的标记 (Editable Annotations)
过滤和缩放 (Filter and Wheel Zoom)
自定义轴标签 (Custom Axis Labels)
自定义系列(Custom Series)
自定义提示(Custom Tooltips)
导出 (Export)
渐变 (Gradients)
Gridlines & Tickmarks
命中测试 (Hit-Testing)
图例和标题 (Legends and Titles)
图例切换 (Legend Toggle)
线标记 (Line Markers)
对数轴 (Logarithmic Axis)
移动平均值 (Moving Averages)
多轴 (Multiple Axes)
多个区域 (Multiple Plot Areas)
调色板 (Palettes)
选择(Selection)
系列选择器 (Series Picker)
滚动和范围选择器 (Scrolling & Range Selectors)
排序(Sorting)
堆积的绘图区域(Stacked Plot Areas)
系列样式(Styling Series)
趋势线 (Trendlines)
缩放与平移 (Zooming and Panning)
仪表盘(Gauge)
概览(Overview)
基本属性(Basic Properties)
子弹仪表盘(BulletGraph)
线性仪表盘(LinearGauge)
径向仪表盘(RadialGauge)
范围(Ranges)
叠加范围(Stacked Ranges)
样式(Styling)
概览(Overview)
悬停(Hover)
焦点(Focus)
范围(Ranges)
仪表盘元素(Gauge Elements)
概览(Overview)
表盘(Face)
指针(Pointer)
径向指针(Needle Pointer)
范围(Ranges)
Thumb
刻度线(Tickmarks)
刻度线文字(Tickmark Text)
文字值(Text Value)
输入(Input)
自动完成(AutoComplete)
概览(Overview)
异步加载(Async Loading)
搜索(Searching)
概览(Overview)
搜索路径(Search Path)
搜索参数(Search Params)
自定义搜索(Custom Search)
自增项目(Auto-Add Items)
筛选(Filtering)
日历(Calendar)
概览(Overview)
范围(Ranges (min/max))
样式(Styling)
Slack Status Calendar
校验(Validation)
颜色选择器(ColorPicker)
概览(Overview)
下拉框(ComboBox)
概览(Overview)
字符串(Strings)
数字和日期(Numbers and Dates)
对象(Objects)
概览(Overview)
主从模式(Master/Detail)
排序与筛选(Sorting and Filtering)
关联(Chaining Combos)
分组(Grouping)
概览(Overview)
自定义分组(Custom Grouping)
类别分组(Category Grouping)
多列(Multi-column)
HTML 内容(HTML Content)
自增项目(Auto-Add Items)
无限滚动(Infinite Scrolling)
下拉(DropDown)
概览(Overview)
颜色输入(InputColor)
概览(Overview)
日期输入(InputDate)
概览(Overview)
格式化(Formatting)
范围(Ranges)
自定义(Customization)
校验(Validation)
日期时间输入(InputDateTime)
概览(Overview)
输入掩码(InputMask)
概览(Overview)
原始值(Raw Value)
提示字符(Prompt Character)
校验(Validation)
数字输入(InputNumber)
概览(Overview)
格式化(Formatting)
步长(Step)
范围(Ranges)
事件输入(InputTime)
概览(Overview)
下拉列表(ListBox)
概览(Overview)
自定义(Customization)
复选框(Checkboxes)
无限滚动(Infinite Scroll)
菜单(Menu)
概览(Overview)
命令(Commands)
值选择器(Value Pickers)
拆分按钮(Split Buttons)
上下文菜单(Context Menus)
分层菜单(Hierarchical Menus)
多项自动完成(MultiAutoComplete)
概览(Overview)
多选(MultiSelect)
概览(Overview)
选中项目(No Checked Item)
弹出框(Popup)
对话框(Dialogs)
警告于提醒(Alerts and Prompts)
动画(Transitions)
弹出编辑器(Popup Editors)
弹出表格(Popup with FlexGrid)
可拖拽的对话框(Draggable Dialogs)
父节点(Popups with Owner Elements)
导航(Nav)
标签面板(TabPanel)
概览(Overview)
标记语言(Markup)
作为容器(Hosting GC Controls)
通过代码添加(Tabs in Code)
Ribbon(Ribbon)
样式(Styling)
禁用和隐藏(Disabled and Invisible Tabs)
分离的内容(Detached Panels)
无障碍访问(Accessibility)
从右到左(Right to Left)
树形视图(TreeView)
性能(Performance)
行为(Behavior)
上下文菜单(Context Menus)
导航(Navigation Tree)
搜索(Searching)
样式(Styling)
概览(Overview)
节点边框(Node Borders)
Accordion Trees(Accordion Trees)
Clean Accordion(Clean Accordion)
节点(Nodes)
概览(Overview)
图像(Images)
复选框(Checkboxes)
自定义内容(Custom Content)
显示选中节点(Showing and Selecting Nodes)
编辑(Editing)
禁用(Disabling)
增加(Adding)
移除(Removing)
刷新(Refreshing)
拖拽(Drag and Drop)
在两个树之间拖拽(Drag and Drop Between Trees)
数据绑定(Data Binding)
初始化状态(Initial State)
指定绑定路径(Heterogeneous Data)
延迟加载(Lazy Loading)
延迟加载 OData(Lazy Loading OData)
延迟重新加载(Lazy Re-loading)
数据分析(OLAP)
透视引擎(PivotEngine)
概览(Overview)
性能(Performance)
定义视图(Defining Views)
服务端数据(Server Side data)
OLAP cubes (MS SSAS)
ComponentOne Data Engine
透视面板(PivotPanel)
概览(Overview)
拖拽字段(Drag & Drop fields)
字段(Fields)
类型(Types)
值字段(Value Fields)
行、列字段(Row/Column Fields)
筛选字段(Filter Fields)
自定义(Customize)
字段设置对话框(Field Settings Dialog)
筛选(Filter)
排序(Sort)
汇总(Summary functions)
别名(ShowAs functions)
格式(Formats)
计算字段(Calculated)
自定义布局(Custom layouts)
默认(Control Template)
堆叠(Stacked)
并排(Side by Side)
2列(2 columns)
仅字段(Fields only)
仅区域(Areas only)
透视表格(PivotGrid)
概览(Overview)
排序(Sort)
展开、折叠行或列(Expand/Collapse Rows and Columns)
Detail Dialog
Outline Mode
合计(Totals)
子合计(Subtotals)
自定义字段单元格(Customize Field cells)
HTML 内容n(HTML Content)
迷你图(Sparklines)
导出(Export)
Excel, PDF, CSV
透视图表(PivotChart)
概览(Overview)
图表类型(Chart Types)
标题(Title)
图例(Legend)
导出(Export)
切片器(Slicer)
PDF(PDF)
概览(Overview)
页面结构(Page structure)
绘制图像(Drawing graphics)
绘制文字(Drawing text)
字体(Fonts)
自定义字体(Custom fonts)
富文本(Rich text)
绘制图片(Drawing images)
自定义页头、页脚(Custom headers and footers)
绘制表格(Drawing tables)
费用报告(Expense report)
Drawing FlexPie (raster))
Drawing FlexPie (SVG)
查看器(Viewer)
Pdf 查看器(PdfViewer)
概览(Overview)
报表查看器(ReportViewer)
概览(Overview)
查看 FlexReport 报表(Viewing FlexReport Reports)
查看 SSRS 报表(Viewing SSRS Reports)
查看 ActiveReprots 报表(Viewing ActiveReports Reports)
Excel(Excel)
费用报告(Expense Report)
工作簿查看器(Workbook Viewer)
交易单
主题:
Default
Cerulean
Clean Dark
Clean Light
Cocoa
Coral
Cyborg
Dark
Flatly
Grayscale
High Contrast
Light
Material
Midnight
Minimal
Modern
Office
Organic
Paper
Simplex
Slate
Superhero
Trust
Zen
import 'bootstrap.css'; import '@grapecity/wijmo.styles/wijmo.css'; import './styles.css'; import * as wjCore from '@grapecity/wijmo'; import * as wjInput from '@grapecity/wijmo.input'; import * as wjGrid from '@grapecity/wijmo.grid'; import * as wjFilter from '@grapecity/wijmo.grid.filter'; import * as wjMultiRow from '@grapecity/wijmo.grid.multirow'; import * as wjGridXlsx from '@grapecity/wijmo.grid.xlsx'; import * as wjXlsx from '@grapecity/wijmo.xlsx'; import * as wjGridPdf from '@grapecity/wijmo.grid.pdf'; import * as wjPdf from '@grapecity/wijmo.pdf'; import { generateSlipData } from './data'; // document.readyState === 'complete' ? init() : window.onload = init; // function init() { let data = generateSlipData(50); let debtorSum; let creditorSum; let balance; let items = new wjCore.CollectionView(data.items); items.pageSize = 5; document.querySelector('#slipNo').value = data.slipNo; document.querySelector('#settlement').value = data.settlement; let inputDate = new wjInput.InputDate('#inputDate'); inputDate.format = 'd'; inputDate.value = data.date; inputDate.min = new Date(data.date.getFullYear(), 0, 1); inputDate.max = new Date(data.date.getFullYear(), 11, 31); let transferSlip = new wjMultiRow.MultiRow('#transferSlip', { itemsSource: items, layoutDefinition: generateLayoutDef() }); let filter = new wjFilter.FlexGridFilter(transferSlip); transferSlip.rowHeaders.columns.clear(); let cv = transferSlip.collectionView; currentPageChanged(); updateSummary(cv); transferSlip.cellEditEnded.addHandler(() => { updateSummary(cv); }); cv.pageChanged.addHandler(() => { updateSummary(cv); currentPageChanged(); }); cv.collectionChanged.addHandler((sender, e) => { let debtorAmt, creditorAmt; if (e.action === wjCore.NotifyCollectionChangedAction.Change && !!e.item) { debtorAmt = +e.item.debtorAmt; creditorAmt = +e.item.creditorAmt; if (!isNaN(debtorAmt)) { e.item.debtorTax = e.item.debtorAmt * 0.09; } if (!isNaN(creditorAmt)) { e.item.creditorTax = e.item.creditorAmt * 0.09; } } }); document.querySelector('#first').addEventListener('click', () => { cv.moveToFirstPage(); }); document.querySelector('#previous').addEventListener('click', () => { cv.moveToPreviousPage(); }); document.querySelector('#next').addEventListener('click', () => { cv.moveToNextPage(); }); document.querySelector('#last').addEventListener('click', () => { cv.moveToLastPage(); }); // Generate the layout definition for the MultiRow control. function generateLayoutDef() { let debtorAccDataMap = buildDataMap('Saralies,Transport,Entertainment,Supplies,Fees'.split(',')), debtorTypeDataMap = buildDataMap(['(none)']), creditorAccDataMap = buildDataMap('Ordinary deposit,Deposits payable,Advance money,Accounts payable'.split(',')), creditorTypeDataMap = buildDataMap('Grape bank,Orange bank,Apple bank,Grape card'.split(',')); return [ { cells: [ { binding: 'debtorAcc', width: 125, header: 'Debtor Account', dataMap: debtorAccDataMap, align: 'center' }, { binding: 'debtorType', width: 125, header: 'Debtor Type', dataMap: debtorTypeDataMap, align: 'center' } ] }, { cells: [ { binding: 'debtorAmt', width: 125, format: 'c2', header: 'Debtor Amount', align: 'center' }, { binding: 'debtorTax', width: 125, format: 'c2', header: 'Debtor Tax', align: 'center', isReadOnly: true } ] }, { cells: [ { binding: 'creditorAcc', width: 125, header: 'Creditor Account', dataMap: creditorAccDataMap, align: 'center' }, { binding: 'creditorType', width: 125, header: 'Creditor Type', dataMap: creditorTypeDataMap, align: 'center' } ] }, { cells: [ { binding: 'creditorAmt', width: 125, format: 'c2', header: 'Creditor Amount', align: 'center' }, { binding: 'creditorTax', width: 125, format: 'c2', header: 'Creditor Tax', align: 'center', isReadOnly: true } ] }, { cells: [ { binding: 'brief', width: 210, header: 'Brief', align: 'center' }, { binding: 'note', width: 210, header: 'Note', align: 'center' } ] }, { cells: [ { binding: 'debtorTaxCategrory', width: 230, header: 'Debtor Tax Category', align: 'center' }, { binding: 'creditorTaxCategory', width: 230, header: 'Creditor Tax Categoty', align: 'center' } ] } ]; } function buildDataMap(items) { let map = []; for (let i = 0; i < items.length; i++) { map.push({ key: i, value: items[i] }); } return new wjGrid.DataMap(map, 'key', 'value'); } // Update summary info for the footer of the multirow control. function updateSummary(cv) { let debtor = wjCore.getAggregate(wjCore.Aggregate.Sum, cv.items, 'debtorAmt'), creditor = wjCore.getAggregate(wjCore.Aggregate.Sum, cv.items, 'creditorAmt'); debtorSum = wjCore.Globalize.format(debtor, 'c'); creditorSum = wjCore.Globalize.format(creditor, 'c'); balance = wjCore.Globalize.format(debtor - creditor, 'c'); document.querySelector('#debtorSum').innerHTML = debtorSum; document.querySelector('#creditorSum').innerHTML = creditorSum; document.querySelector('#balance').innerHTML = balance; } function currentPageChanged() { let cv = transferSlip.collectionView, curr = wjCore.format('{current:n0} / {count:n0}', { current: cv.pageIndex + 1, count: cv.pageCount }); document.querySelector('#current').innerHTML = curr; if (cv.pageIndex === 0) { document.querySelector('#first').setAttribute('disabled', 'true'); document.querySelector('#previous').setAttribute('disabled', 'true'); } else { document.querySelector('#first').removeAttribute('disabled'); document.querySelector('#previous').removeAttribute('disabled'); } if (cv.pageIndex === cv.pageCount - 1) { document.querySelector('#last').setAttribute('disabled', 'true'); document.querySelector('#next').setAttribute('disabled', 'true'); } else { document.querySelector('#last').removeAttribute('disabled'); document.querySelector('#next').removeAttribute('disabled'); } } document.querySelector('#exportXlsx').addEventListener('click', () => { exportToExcel(); }); document.querySelector('#exportPdf').addEventListener('click', () => { exportToPDF(); }); // Export the records of current page to xlsx file. function exportToExcel() { let workbook = wjGridXlsx.FlexGridXlsxConverter.save(transferSlip); let workbookRow = new wjXlsx.WorkbookRow(); let workbookFill = new wjXlsx.WorkbookFill(); workbookFill.color = '#8080FF'; let workbookFont = new wjXlsx.WorkbookFont(); workbookFont.bold = true; let workbookStyle = new wjXlsx.WorkbookStyle(); workbookStyle.fill = workbookFill; workbookStyle.font = workbookFont; workbookStyle.hAlign = wjXlsx.HAlign.Center; let workbookCell = new wjXlsx.WorkbookCell(); workbookCell.value = 'Date'; workbookCell.style = workbookStyle; workbookRow.cells.push(workbookCell); workbookCell = new wjXlsx.WorkbookCell(); workbookCell.value = data.date; let dateCellStyle = new wjXlsx.WorkbookStyle(); dateCellStyle.format = 'MM/dd/yyyy'; workbookCell.style = dateCellStyle; workbookRow.cells.push(workbookCell); workbookCell = new wjXlsx.WorkbookCell(); workbookCell.value = 'Slip No'; workbookCell.style = workbookStyle; workbookRow.cells.push(workbookCell); workbookCell = new wjXlsx.WorkbookCell(); workbookCell.value = data.slipNo; workbookRow.cells.push(workbookCell); workbookCell = new wjXlsx.WorkbookCell(); workbookCell.value = 'Settlement'; workbookCell.style = workbookStyle; workbookRow.cells.push(workbookCell); workbookCell = new wjXlsx.WorkbookCell(); workbookCell.value = data.settlement; workbookRow.cells.push(workbookCell); workbook.sheets[0].rows.splice(0, 0, workbookRow); workbook.sheets[0].frozenPane.rows = 3; workbookRow = new wjXlsx.WorkbookRow(); workbookFill = new wjXlsx.WorkbookFill(); workbookFill.color = '#99B4D1'; workbookStyle = new wjXlsx.WorkbookStyle(); workbookStyle.fill = workbookFill; workbookStyle.hAlign = wjXlsx.HAlign.Center; workbookCell = new wjXlsx.WorkbookCell(); workbookCell.value = 'Debtor Sum'; workbookCell.style = workbookStyle; workbookRow.cells.push(workbookCell); workbookCell = new wjXlsx.WorkbookCell(); workbookCell.value = debtorSum; workbookCell.style = workbookStyle; workbookRow.cells.push(workbookCell); workbookCell = new wjXlsx.WorkbookCell(); workbookCell.value = 'Creditor Sum'; workbookCell.style = workbookStyle; workbookRow.cells.push(workbookCell); workbookCell = new wjXlsx.WorkbookCell(); workbookCell.value = creditorSum; workbookCell.style = workbookStyle; workbookRow.cells.push(workbookCell); workbookCell = new wjXlsx.WorkbookCell(); workbookCell.value = 'Balance'; workbookCell.style = workbookStyle; workbookRow.cells.push(workbookCell); workbookCell = new wjXlsx.WorkbookCell(); workbookCell.value = balance; workbookCell.style = workbookStyle; workbookRow.cells.push(workbookCell); workbook.sheets[0].rows.push(workbookRow); workbook.saveAsync('TransferSlip.xlsx'); } // Save the records of current page to PDF file. function exportToPDF() { let doc = new wjPdf.PdfDocument({ header: { declarative: { text: '\t&[Page]\\&[Pages]' } }, footer: { declarative: { text: '\t&[Page]\\&[Pages]' } }, ended: function (sender, args) { wjPdf.saveBlob(args.blob, 'TransferSlip.pdf'); } }), settings = { styles: { cellStyle: { backgroundColor: '#ffffff', borderColor: '#c6c6c6' }, altCellStyle: { backgroundColor: '#f9f9f9' }, headerCellStyle: { backgroundColor: '#eaeaea' } } }, font, drawTextSetting, thinPen = new wjPdf.PdfPen('#000000', 0.5); // Draw header of the transfer slip. doc.paths .rect(0.5, 0.5, 50, 21) .fill('#8080FF') .moveTo(0, 0).lineTo(334, 0) .moveTo(334, 0).lineTo(334, 22) .moveTo(0, 22).lineTo(334, 22) .moveTo(0, 0).lineTo(0, 22).stroke(thinPen); doc.drawText('Date', 3.5, 5.5, drawTextSetting); doc.drawText(wjCore.Globalize.format(data.date, 'd'), 53.5, 5.5, drawTextSetting); doc.paths .rect(130.5, 0.5, 50, 21) .fill('#8080FF'); doc.drawText('Slip No', 133.5, 5.5, drawTextSetting); doc.drawText(data.slipNo, 183.5, 5.5, drawTextSetting); doc.paths .rect(230.5, 0.5, 50, 21) .fill('#8080FF'); doc.drawText('Settlement', 233.5, 5.5, drawTextSetting); doc.drawText(data.settlement, 283.5, 5.5, drawTextSetting); doc.moveDown(); // Draw the body of the transfer slip. wjGridPdf.FlexGridPdfConverter.draw(transferSlip, doc, null, null, settings); // Draw the footer of the transfer slip. doc.paths .rect(0.5, 274.5, 380, 21) .fill('#99B4D1') .moveTo(0, 274).lineTo(381, 274) .moveTo(381, 274).lineTo(381, 296) .moveTo(0, 296).lineTo(381, 296) .moveTo(0, 274).lineTo(0, 296) .moveTo(60, 274).lineTo(60, 296) .moveTo(120, 274).lineTo(120, 296) .moveTo(180, 274).lineTo(180, 296) .moveTo(240, 274).lineTo(240, 296) .moveTo(320, 274).lineTo(320, 296).stroke(thinPen); doc.drawText('Debtor Sum', 3.5, 279.5, drawTextSetting); doc.drawText(debtorSum, 63.5, 279.5, drawTextSetting); doc.drawText('Creditor Sum', 123.5, 279.5, drawTextSetting); doc.drawText(creditorSum, 183.5, 279.5, drawTextSetting); doc.drawText('Balance', 243.5, 279.5, drawTextSetting); doc.drawText(balance, 323.5, 279.5, drawTextSetting); doc.end(); } }
<!DOCTYPE html> <html lang="en"> <head> <meta charset="utf-8"> <meta http-equiv="X-UA-Compatible" content="IE=edge"> <title>GrapeCity Wijmo MultiRow Transfer Slip</title> <meta name="viewport" content="width=device-width, initial-scale=1.0"> <!-- SystemJS --> <script src="node_modules/systemjs/dist/system.src.js"></script> <script src="systemjs.config.js"></script> <script> System.import('./src/app'); </script> </head> <body> <div class="container-fluid"> <div class="row show-grid"> <div class="col-md-1 grid-title">Date</div> <div class="col-md-2"> <div id="inputDate"></div> </div> <div class="col-md-2 grid-title">Slip No</div> <div class="col-md-2"> <input id="slipNo" type="text" class="form-control" /> </div> <div class="col-md-2 grid-title">Settlement</div> <div class="col-md-2"> <input id="settlement" type="text" class="form-control" /> </div> </div> <div id="transferSlip"></div> <div class="row show-grid"> <div style="width:125px;" class="summary-cell">Debtor Sum</div> <div style="width:125px;" class="summary-cell"><span id="debtorSum"></span></div> <div style="width:125px;" class="summary-cell">Creditor Sum</div> <div style="width:125px;" class="summary-cell"><span id="creditorSum"></span></div> <div style="width:110px;" class="summary-cell">Balance</div> <div style="width:100px;" class="summary-cell"><span id="balance"></span></div> </div> <div class="pull-right btn-group"> <button class="btn btn-default" id="first"> <span class="glyphicon glyphicon-fast-backward"></span> </button> <button class="btn btn-default" id="previous"> <span class="glyphicon glyphicon-backward"></span> </button> <button id="current" type="button" class="btn" disabled style="width:100px"> </button> <button class="btn btn-default" id="next"> <span class="glyphicon glyphicon-forward"></span> </button> <button class="btn btn-default" id="last"> <span class="glyphicon glyphicon-fast-forward"></span> </button> </div> <div class="btn-group"> <button class="btn btn-default" id="exportXlsx"> Export to Excel </button> <button class="btn btn-default" id="exportPdf"> Export to PDF </button> </div> </div> </body> </html>
export function generateSlipData(count) { let slipData = {}, items = []; for (let i = 0; i < count; i++) { let debtorAcc = Math.floor(5 * Math.random()); let debtorType = 0; let debtorAmt = Math.round(10000 * Math.random()); let creditorAcc = Math.floor(4 * Math.random()); let creditorType = Math.floor(4 * Math.random()); let creditorAmt = Math.round(10000 * Math.random()); items.push({ debtorAcc: debtorAcc, debtorType: debtorType, debtorAmt: debtorAmt, debtorTax: debtorAmt * 0.09, creditorAcc: creditorAcc, creditorType: creditorType, creditorAmt: creditorAmt, creditorTax: creditorAmt * 0.09, brief: '', note: '', debtorTaxCategrory: '', creditorTaxCategory: '' }); } slipData.items = items; slipData.date = new Date(); slipData.slipNo = 's128'; slipData.settlement = 'Normal'; return slipData; }
.wj-multirow { max-height: 400px; margin: 6px 0; } .show-grid { margin-left: 6px; margin-top: 5px; margin-bottom: 5px; border-radius: 4px; } .show-grid [class^=col-] { padding-top: 5px; padding-bottom: 5px; border-style: solid solid solid none; border-width: 1px; border-color: #000000; height: 44px; } .show-grid > .grid-title { background-color: #8080ff; font-size: 18px; font-weight: bold; } .show-grid > .summary-cell { padding: 5px; border-style: solid solid solid none; border-width: 1px; border-color: #000000; background-color: #99B4D1; font-weight: bold; text-align: center; float: left; } .show-grid > div:first-child { border-left-style: solid; border-radius: 4px 0px 0px 4px; } .show-grid > div:last-child { border-radius: 0px 4px 4px 0px; }
(function (global) { System.config({ transpiler: 'plugin-babel', babelOptions: { es2015: true }, meta: { '*.css': { loader: 'css' } }, paths: { // paths serve as alias 'npm:': 'node_modules/' }, // map tells the System loader where to look for things map: { 'jszip': 'npm:jszip/dist/jszip.js', '@grapecity/wijmo': 'npm:@grapecity/wijmo/index.js', '@grapecity/wijmo.input': 'npm:@grapecity/wijmo.input/index.js', '@grapecity/wijmo.styles': 'npm:@grapecity/wijmo.styles', '@grapecity/wijmo.cultures': 'npm:@grapecity/wijmo.cultures', '@grapecity/wijmo.chart': 'npm:@grapecity/wijmo.chart/index.js', '@grapecity/wijmo.chart.analytics': 'npm:@grapecity/wijmo.chart.analytics/index.js', '@grapecity/wijmo.chart.animation': 'npm:@grapecity/wijmo.chart.animation/index.js', '@grapecity/wijmo.chart.annotation': 'npm:@grapecity/wijmo.chart.annotation/index.js', '@grapecity/wijmo.chart.finance': 'npm:@grapecity/wijmo.chart.finance/index.js', '@grapecity/wijmo.chart.finance.analytics': 'npm:@grapecity/wijmo.chart.finance.analytics/index.js', '@grapecity/wijmo.chart.hierarchical': 'npm:@grapecity/wijmo.chart.hierarchical/index.js', '@grapecity/wijmo.chart.interaction': 'npm:@grapecity/wijmo.chart.interaction/index.js', '@grapecity/wijmo.chart.radar': 'npm:@grapecity/wijmo.chart.radar/index.js', '@grapecity/wijmo.chart.render': 'npm:@grapecity/wijmo.chart.render/index.js', '@grapecity/wijmo.gauge': 'npm:@grapecity/wijmo.gauge/index.js', '@grapecity/wijmo.grid': 'npm:@grapecity/wijmo.grid/index.js', '@grapecity/wijmo.grid.detail': 'npm:@grapecity/wijmo.grid.detail/index.js', '@grapecity/wijmo.grid.filter': 'npm:@grapecity/wijmo.grid.filter/index.js', '@grapecity/wijmo.grid.grouppanel': 'npm:@grapecity/wijmo.grid.grouppanel/index.js', '@grapecity/wijmo.grid.multirow': 'npm:@grapecity/wijmo.grid.multirow/index.js', '@grapecity/wijmo.grid.pdf': 'npm:@grapecity/wijmo.grid.pdf/index.js', '@grapecity/wijmo.grid.sheet': 'npm:@grapecity/wijmo.grid.sheet/index.js', '@grapecity/wijmo.grid.xlsx': 'npm:@grapecity/wijmo.grid.xlsx/index.js', '@grapecity/wijmo.nav': 'npm:@grapecity/wijmo.nav/index.js', '@grapecity/wijmo.odata': 'npm:@grapecity/wijmo.odata/index.js', '@grapecity/wijmo.olap': 'npm:@grapecity/wijmo.olap/index.js', '@grapecity/wijmo.pdf': 'npm:@grapecity/wijmo.pdf/index.js', '@grapecity/wijmo.viewer': 'npm:@grapecity/wijmo.viewer/index.js', '@grapecity/wijmo.xlsx': 'npm:@grapecity/wijmo.xlsx/index.js', 'jszip': 'npm:jszip/dist/jszip.js', 'bootstrap.css': 'npm:bootstrap/dist/css/bootstrap.min.css', 'css': 'npm:systemjs-plugin-css/css.js', 'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js', 'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js' }, // packages tells the System loader how to load when no filename and/or no extension packages: { src: { defaultExtension: 'js' }, "node_modules": { defaultExtension: 'js' }, } }); })(this);

import 'bootstrap.css';
import '@mescius/wijmo.styles/wijmo.css';
import './styles.css';
//
import * as wjCore from '@mescius/wijmo';
import * as wjInput from '@mescius/wijmo.input';
import * as wjGrid from '@mescius/wijmo.grid';
import * as wjFilter from '@mescius/wijmo.grid.filter';
import * as wjPdf from '@mescius/wijmo.pdf';
import * as wjMultirow from '@mescius/wijmo.grid.multirow';
import * as wjGridXlsx from '@mescius/wijmo.grid.xlsx';
import * as wjXlsx from '@mescius/wijmo.xlsx';
import * as wjGridPdf from '@mescius/wijmo.grid.pdf';
import '@angular/compiler';
import { Component, Inject, enableProdMode, ViewChild, AfterViewInit, ɵresolveComponentResources } from '@angular/core';
import { BrowserModule, bootstrapApplication } from '@angular/platform-browser';
import { WjGridMultirowModule } from '@mescius/wijmo.angular2.grid.multirow';
import { WjInputModule } from '@mescius/wijmo.angular2.input';
import { DataService, SlipData, Line } from './app.data';
//
@Component({
standalone: true,
providers: [DataService],
imports: [WjGridMultirowModule, WjInputModule, BrowserModule],
selector: 'app-component',
templateUrl: 'src/app.component.html'
})
export class AppComponent implements AfterViewInit {
@ViewChild('transferSlip', { static: true }) transferSlip: wjMultirow.MultiRow;
data: SlipData;
items: wjCore.CollectionView;
layoutDefinition: Line[];
cv: wjCore.CollectionView;
debtorSum: string;
creditorSum: string;
balance: string;
minDate:Date;
maxDate:Date;
//
currentDescription: string;
slipNo: string;
settlement: string;
// DataSvc will be passed by derived classes
constructor(@Inject(DataService) private dataService: DataService) {
this.data = this.dataService.generateSlipData(50);
this.items = new wjCore.CollectionView(this.data.items);
this.layoutDefinition = dataService.generateLayoutDef();
this.minDate = new Date(this.data.date.getFullYear(), 0, 1);
this.maxDate = new Date(this.data.date.getFullYear(), 11, 31);
}
//
ngAfterViewInit() {
this.items.pageSize = 5;
this.slipNo = this.data.slipNo;
this.settlement = this.data.settlement;
let filter = new wjFilter.FlexGridFilter(this.transferSlip);
this.transferSlip.rowHeaders.columns.clear();
this.cv = <wjCore.CollectionView>this.transferSlip.collectionView;
this._currentPageChanged();
this._updateSummary();
this.transferSlip.cellEditEnded.addHandler(() => {
this._updateSummary();
});
this.cv.pageChanged.addHandler(() => {
this._updateSummary();
this._currentPageChanged();
});
this.cv.collectionChanged.addHandler((sender: any, e: wjCore.NotifyCollectionChangedEventArgs) => {
let debtorAmt: number,
creditorAmt: number;
if (e.action === wjCore.NotifyCollectionChangedAction.Change && !!e.item) {
debtorAmt = +e.item.debtorAmt;
creditorAmt = +e.item.creditorAmt;
if (!isNaN(debtorAmt)) {
e.item.debtorTax = e.item.debtorAmt * 0.09;
}
if (!isNaN(creditorAmt)) {
e.item.creditorTax = e.item.creditorAmt * 0.09;
}
}
});
}
//
onGotoPageClick(command: string) {
let cv = this.cv;
if (command === 'first') {
cv.moveToFirstPage();
} else if (command === 'previous') {
cv.moveToPreviousPage();
} else if (command === 'next') {
cv.moveToNextPage();
} else if (command === 'last') {
cv.moveToLastPage();
}
}
//
onExportXlsxClick() {
let workbook = wjGridXlsx.FlexGridXlsxConverter.save(this.transferSlip);
let workbookRow = new wjXlsx.WorkbookRow();
let workbookFill = new wjXlsx.WorkbookFill();
workbookFill.color = '#8080FF';
let workbookFont = new wjXlsx.WorkbookFont();
workbookFont.bold = true;
let workbookStyle = new wjXlsx.WorkbookStyle();
workbookStyle.fill = workbookFill;
workbookStyle.font = workbookFont;
workbookStyle.hAlign = wjXlsx.HAlign.Center;
let workbookCell = new wjXlsx.WorkbookCell();
workbookCell.value = '日付';
workbookCell.style = workbookStyle;
workbookRow.cells.push(workbookCell);
workbookCell = new wjXlsx.WorkbookCell();
workbookCell.value = this.data.date;
let dateCellStyle = new wjXlsx.WorkbookStyle();
dateCellStyle.format = 'd';
workbookCell.style = dateCellStyle;
workbookRow.cells.push(workbookCell);
workbookCell = new wjXlsx.WorkbookCell();
workbookCell.value = '伝票No'
workbookCell.style = workbookStyle;
workbookRow.cells.push(workbookCell);
workbookCell = new wjXlsx.WorkbookCell();
workbookCell.value = this.data.slipNo;
workbookRow.cells.push(workbookCell);
workbookCell = new wjXlsx.WorkbookCell();
workbookCell.value = '決算';
workbookCell.style = workbookStyle;
workbookRow.cells.push(workbookCell);
workbookCell = new wjXlsx.WorkbookCell();
workbookCell.value = this.data.settlement;
workbookRow.cells.push(workbookCell);
workbook.sheets[0].rows.splice(0, 0, workbookRow);
workbook.sheets[0].frozenPane.rows = 3;
workbookRow = new wjXlsx.WorkbookRow();
workbookFill = new wjXlsx.WorkbookFill();
workbookFill.color = '#99B4D1';
workbookStyle = new wjXlsx.WorkbookStyle();
workbookStyle.fill = workbookFill;
workbookStyle.hAlign = wjXlsx.HAlign.Center;
workbookCell = new wjXlsx.WorkbookCell();
workbookCell.value = '貸方合計';
workbookCell.style = workbookStyle;
workbookRow.cells.push(workbookCell);
workbookCell = new wjXlsx.WorkbookCell();
workbookCell.value = this.debtorSum;
workbookCell.style = workbookStyle;
workbookRow.cells.push(workbookCell);
workbookCell = new wjXlsx.WorkbookCell();
workbookCell.value = '借方合計';
workbookCell.style = workbookStyle;
workbookRow.cells.push(workbookCell);
workbookCell = new wjXlsx.WorkbookCell();
workbookCell.value = this.creditorSum;
workbookCell.style = workbookStyle;
workbookRow.cells.push(workbookCell);
workbookCell = new wjXlsx.WorkbookCell();
workbookCell.value = '賃借バランス';
workbookCell.style = workbookStyle;
workbookRow.cells.push(workbookCell);
workbookCell = new wjXlsx.WorkbookCell();
workbookCell.value = this.balance;
workbookCell.style = workbookStyle;
workbookRow.cells.push(workbookCell);
workbook.sheets[0].rows.push(workbookRow);
workbook.saveAsync('TransferSlip.xlsx');
}
//
onExportPdfClick() {
let doc = new wjPdf.PdfDocument({
header: {
declarative: {
text: '\t&[Page] / &[Pages]'
}
},
footer: {
declarative: {
text: '\t&[Page] / &[Pages]'
}
},
ended: function (sender: wjPdf.PdfDocument, args: wjPdf.PdfDocumentEndedEventArgs) {
wjPdf.saveBlob(args.blob, 'TransferSlip.pdf')
}
}),
settings = {
styles: {
cellStyle: {
font: { family: 'ipaexg' },
backgroundColor: '#ffffff',
borderColor: '#c6c6c6'
},
altCellStyle: {
backgroundColor: '#f9f9f9'
},
headerCellStyle: {
backgroundColor: '#eaeaea'
}
}
}, font, drawTextSetting, thinPen = new wjPdf.PdfPen('#000000', 0.5);
doc.registerFont({ source: `https://${window.location.host}/wijmo/demos/fonts/ipaexg.ttf`, name: 'ipaexg' });
doc.setFont(new wjPdf.PdfFont('ipaexg'));
// Draw header of the transfer slip.
doc.paths
.rect(0.5, 0.5, 50, 21)
.fill('#8080FF')
.moveTo(0, 0).lineTo(334, 0)
.moveTo(334, 0).lineTo(334, 22)
.moveTo(0, 22).lineTo(334, 22)
.moveTo(0, 0).lineTo(0, 22).stroke(thinPen);
doc.drawText('日付', 3.5, 5.5, drawTextSetting);
doc.drawText(wjCore.Globalize.format(this.data.date, 'd'), 53.5, 5.5, drawTextSetting);
doc.paths
.rect(130.5, 0.5, 50, 21)
.fill('#8080FF');
doc.drawText('伝票No', 133.5, 5.5, drawTextSetting);
doc.drawText(this.data.slipNo, 183.5, 5.5, drawTextSetting);
doc.paths
.rect(230.5, 0.5, 50, 21)
.fill('#8080FF');
doc.drawText('決算', 233.5, 5.5, drawTextSetting);
doc.drawText(this.data.settlement, 283.5, 5.5, drawTextSetting);
doc.moveDown();
// Draw the body of the transfer slip.
wjGridPdf.FlexGridPdfConverter.draw(this.transferSlip, doc, null, null, settings);
// Draw the footer of the transfer slip.
doc.paths
.rect(0.5, 274.5, 380, 21)
.fill('#99B4D1')
.moveTo(0, 274).lineTo(381, 274)
.moveTo(381, 274).lineTo(381, 296)
.moveTo(0, 296).lineTo(381, 296)
.moveTo(0, 274).lineTo(0, 296)
.moveTo(60, 274).lineTo(60, 296)
.moveTo(120, 274).lineTo(120, 296)
.moveTo(180, 274).lineTo(180, 296)
.moveTo(240, 274).lineTo(240, 296)
.moveTo(320, 274).lineTo(320, 296).stroke(thinPen);
doc.drawText('貸方合計', 3.5, 279.5, drawTextSetting);
doc.drawText(this.debtorSum, 63.5, 279.5, drawTextSetting);
doc.drawText('借方合計', 123.5, 279.5, drawTextSetting);
doc.drawText(this.creditorSum, 183.5, 279.5, drawTextSetting);
doc.drawText('賃借バランス', 243.5, 279.5, drawTextSetting);
doc.drawText(this.balance, 323.5, 279.5, drawTextSetting);
doc.end();
}
//
private _updateSummary() {
let debtor = wjCore.getAggregate(wjCore.Aggregate.Sum, this.cv.items, 'debtorAmt'),
creditor = wjCore.getAggregate(wjCore.Aggregate.Sum, this.cv.items, 'creditorAmt');
this.debtorSum = wjCore.Globalize.format(debtor, 'c');
this.creditorSum = wjCore.Globalize.format(creditor, 'c');
this.balance = wjCore.Globalize.format(debtor - creditor, 'c');
}
//
private _currentPageChanged() {
let curr = wjCore.format('{current:n0} / {count:n0}', {
current: this.cv.pageIndex + 1,
count: this.cv.pageCount
});
this.currentDescription = curr;
if (this.cv.pageIndex === 0) {
document.querySelector('#first').setAttribute('disabled', 'true');
document.querySelector('#previous').setAttribute('disabled', 'true');
} else {
document.querySelector('#first').removeAttribute('disabled');
document.querySelector('#previous').removeAttribute('disabled');
}
if (this.cv.pageIndex === this.cv.pageCount - 1) {
document.querySelector('#last').setAttribute('disabled', 'true');
document.querySelector('#next').setAttribute('disabled', 'true');
} else {
document.querySelector('#last').removeAttribute('disabled');
document.querySelector('#next').removeAttribute('disabled');
}
}
}
//\\
//
enableProdMode();
// Resolve resources (templateUrl, styleUrls etc), After resolution all URLs have been converted into `template` strings.
ɵresolveComponentResources(fetch).then(() => {
// Bootstrap application
bootstrapApplication(AppComponent).catch(err => console.error(err));
});
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo MultiRow Transfer Slip</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- Polyfills -->
<script src="node_modules/core-js/client/shim.min.js"></script>
<script src="node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.21.5/system.src.js" integrity="sha512-skZbMyvYdNoZfLmiGn5ii6KmklM82rYX2uWctBhzaXPxJgiv4XBwJnFGr5k8s+6tE1pcR1nuTKghozJHyzMcoA==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="container-fluid">
<div class="row show-grid">
<div class="col-md-1 grid-title">日付</div>
<div class="col-md-2">
<wj-input-date [format]="'d'" [value]="data.date" [min]="minDate"
[max]="maxDate"></wj-input-date>
</div>
<div class="col-md-2 grid-title">伝票No
</div>
<div class="col-md-2">
<input [(value)]="slipNo" type="text" class="form-control" />
</div>
<div class="col-md-2 grid-title">決算</div>
<div class="col-md-2">
<input [(value)]="settlement" type="text" class="form-control" />
</div>
</div>
<wj-multi-row #transferSlip [itemsSource]="items" [layoutDefinition]="layoutDefinition"></wj-multi-row>
<div class="row show-grid">
<div style="width:125px;" class="summary-cell">貸方合計</div>
<div style="width:125px;" class="summary-cell"><span [innerHTML]="debtorSum"></span></div>
<div style="width:125px;" class="summary-cell">借方合計</div>
<div style="width:125px;" class="summary-cell"><span [innerHTML]="creditorSum"></span></div>
<div style="width:110px;" class="summary-cell">賃借バランス</div>
<div style="width:100px;" class="summary-cell"><span [innerHTML]="balance"></span></div>
</div>
<div class="pull-right btn-group">
<button class="btn btn-default" (click)="onGotoPageClick('first')" id="first">
<span class="glyphicon glyphicon-fast-backward"></span>
</button>
<button class="btn btn-default" (click)="onGotoPageClick('previous')" id="previous">
<span class="glyphicon glyphicon-backward"></span>
</button>
<button id="current" type="button" class="btn" disabled style="width:100px" [innerHTML]="currentDescription">
</button>
<button class="btn btn-default" (click)="onGotoPageClick('next')" id="next">
<span class="glyphicon glyphicon-forward"></span>
</button>
<button class="btn btn-default" (click)="onGotoPageClick('last')" id="last">
<span class="glyphicon glyphicon-fast-forward"></span>
</button>
</div>
<div class="btn-group">
<button class="btn btn-default" (click)="onExportXlsxClick()">
Excelにエクスポート
</button>
<button class="btn btn-default" (click)="onExportPdfClick()">
PDFにエクスポート
</button>
</div>
</div>
import { Injectable } from '@angular/core';
import * as wjGrid from '@mescius/wijmo.grid';
export interface SlipData {
items: SlipDataItem[];
date: Date;
slipNo: string;
settlement: string;
}
export interface SlipDataItem {
debtorAcc: number;
debtorType: number;
debtorAmt: number;
debtorTax: number;
creditorAcc: number;
creditorType: number;
creditorAmt: number;
creditorTax: number;
brief: string;
note: string;
debtorTaxCategrory: string;
creditorTaxCategory: string;
}
export interface Cell {
binding: string;
header: string;
cssClass?: string;
format?: string;
isReadOnly?: boolean;
wordWrap?: boolean;
width?: number;
colspan?: number;
align?: string;
dataMap?: wjGrid.DataMap;
}
export interface Line {
cells: Cell[];
}
@Injectable()
export class DataService {
generateSlipData(count: number): SlipData {
let slipData: any = {},
items = [];
for (let i = 0; i < count; i++) {
let debtorAcc = 0;
let debtorType = Math.floor(3 * Math.random());
let debtorAmt = Math.round(10000 * Math.random());
let creditorAcc = 0;
let creditorType = Math.floor(3 * Math.random());
let creditorAmt = Math.round(10000 * Math.random());
items.push({
debtorAcc: debtorAcc,
debtorType: debtorType,
debtorAmt: debtorAmt,
debtorTax: debtorAmt * 0.09,
creditorAcc: creditorAcc,
creditorType: creditorType,
creditorAmt: creditorAmt,
creditorTax: creditorAmt * 0.09,
brief: `${i % 12 + 1}月支給分`,
note: '',
debtorTaxCategrory: '対象外',
creditorTaxCategory: ''
});
}
slipData.items = items;
slipData.date = new Date();
slipData.slipNo = '128';
slipData.settlement = '通常';
return slipData;
}
generateLayoutDef(): Line[] {
let debtorAccDataMap = buildDataMap('給料手当,旅費交通費,接待交際費,消耗品費,支払手数料'.split(',')),
debtorTypeDataMap = buildDataMap('(指定なし),現金,当座預金'.split(',')),
creditorAccDataMap = buildDataMap('普通預金,売上高,現金'.split(',')),
creditorTypeDataMap = buildDataMap('雇用保険,住民税,社会保険'.split(','));
return [
{
cells: [
{ binding: 'debtorAcc', width: 125, header: '借方勘定', dataMap: debtorAccDataMap, align: 'center' },
{ binding: 'debtorType', width: 125, header: '借方補助', dataMap: debtorTypeDataMap, align: 'center' }
]
},
{
cells: [
{ binding: 'debtorAmt', width: 125, format: 'c', header: '借方金額', align: 'center' },
{ binding: 'debtorTax', width: 125, format: 'c', header: '借方消費税', align: 'center', isReadOnly: true }
]
},
{
cells: [
{ binding: 'creditorAcc', width: 125, header: '貸方勘定', dataMap: creditorAccDataMap, align: 'center' },
{ binding: 'creditorType', width: 125, header: '貸方補助', dataMap: creditorTypeDataMap, align: 'center' }
]
},
{
cells: [
{ binding: 'creditorAmt', width: 125, format: 'c', header: '貸方金額', align: 'center' },
{ binding: 'creditorTax', width: 125, format: 'c', header: '貸方消費税', align: 'center', isReadOnly: true }
]
},
{
cells: [
{ binding: 'brief', width: 150, header: '摘要', align: 'center' },
{ binding: 'note', width: 150, header: '付箋', align: 'center' }
]
},
{
cells: [
{ binding: 'debtorTaxCategrory', width: 150, header: '借方税区分', align: 'center' },
{ binding: 'creditorTaxCategory', width: 150, header: '貸方税区分', align: 'center' }
]
}
];
}
}
function buildDataMap(items: string[]) {
let map = [];
for (let i = 0; i < items.length; i++) {
map.push({ key: i, value: items[i] });
}
return new wjGrid.DataMap(map, 'key', 'value');
}
.wj-multirow {
max-height: 400px;
margin: 6px 0;
}
.show-grid {
margin-left: 6px;
margin-top: 5px;
margin-bottom: 5px;
border-radius: 4px;
}
.show-grid [class^=col-] {
padding-top: 5px;
padding-bottom: 5px;
border-style: solid solid solid none;
border-width: 1px;
border-color: #000000;
height: 44px;
}
.show-grid > .grid-title {
background-color: #8080ff;
font-size: 18px;
font-weight: bold;
}
.show-grid > .summary-cell {
padding: 5px;
border-style: solid solid solid none;
border-width: 1px;
border-color: #000000;
background-color: #99B4D1;
font-weight: bold;
text-align: center;
float: left;
}
.show-grid > div:first-child {
border-left-style: solid;
border-radius: 4px 0px 0px 4px;
}
.show-grid > div:last-child {
border-radius: 0px 4px 4px 0px;
}
(function (global) {
SystemJS.config({
transpiler: './plugin-typescript.js',
typescriptOptions: {
"target": "ES2022",
"module": "system",
"emitDecoratorMetadata": true,
"experimentalDecorators": true,
},
baseURL: 'node_modules/',
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'systemjs-plugin-css' },
'*.mjs': {
format: 'esm'
},
},
paths: {
// paths serve as alias
'npm:': ''
},
packageConfigPaths: [
'/node_modules/*/package.json',
"/node_modules/@angular/*/package.json",
"/node_modules/@mescius/*/package.json"
],
map: {
'core-js': 'https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js',
'typescript': 'https://cdnjs.cloudflare.com/ajax/libs/typescript/5.2.2/typescript.min.js',
"rxjs": "https://cdnjs.cloudflare.com/ajax/libs/rxjs/7.8.1/rxjs.umd.min.js",
'systemjs-plugin-css': 'https://cdn.jsdelivr.net/npm/systemjs-plugin-css@0.1.37/css.js',
'@mescius/wijmo': 'npm:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'npm:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'npm:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'npm:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'npm:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'npm:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'npm:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'npm:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'npm:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'npm:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'npm:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'npm:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'npm:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'npm:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'npm:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'npm:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'npm:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'npm:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'npm:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'npm:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'npm:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'npm:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'npm:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'npm:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'npm:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'npm:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'npm:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'npm:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'npm:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'npm:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'npm:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.nav': 'npm:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'npm:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'npm:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'npm:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'npm:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'npm:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'npm:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'npm:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'npm:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'npm:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.touch': 'npm:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'npm:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.barcode': 'npm:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'npm:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'npm:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'npm:@mescius/wijmo.barcode.specialized/index.js',
"@mescius/wijmo.angular2.chart.analytics": "npm:@mescius/wijmo.angular2.chart.analytics/index.js",
"@mescius/wijmo.angular2.chart.animation": "npm:@mescius/wijmo.angular2.chart.animation/index.js",
"@mescius/wijmo.angular2.chart.annotation": "npm:@mescius/wijmo.angular2.chart.annotation/index.js",
"@mescius/wijmo.angular2.chart.finance.analytics": "npm:@mescius/wijmo.angular2.chart.finance.analytics/index.js",
"@mescius/wijmo.angular2.chart.finance": "npm:@mescius/wijmo.angular2.chart.finance/index.js",
"@mescius/wijmo.angular2.chart.hierarchical": "npm:@mescius/wijmo.angular2.chart.hierarchical/index.js",
"@mescius/wijmo.angular2.chart.interaction": "npm:@mescius/wijmo.angular2.chart.interaction/index.js",
"@mescius/wijmo.angular2.chart.radar": "npm:@mescius/wijmo.angular2.chart.radar/index.js",
'@mescius/wijmo.angular2.chart.map': 'npm:@mescius/wijmo.angular2.chart.map/index.js',
"@mescius/wijmo.angular2.chart": "npm:@mescius/wijmo.angular2.chart/index.js",
"@mescius/wijmo.angular2.core": "npm:@mescius/wijmo.angular2.core/index.js",
"@mescius/wijmo.angular2.gauge": "npm:@mescius/wijmo.angular2.gauge/index.js",
"@mescius/wijmo.angular2.grid.detail": "npm:@mescius/wijmo.angular2.grid.detail/index.js",
"@mescius/wijmo.angular2.grid.filter": "npm:@mescius/wijmo.angular2.grid.filter/index.js",
"@mescius/wijmo.angular2.grid.grouppanel": "npm:@mescius/wijmo.angular2.grid.grouppanel/index.js",
"@mescius/wijmo.angular2.grid.search": "npm:@mescius/wijmo.angular2.grid.search/index.js",
"@mescius/wijmo.angular2.grid.multirow": "npm:@mescius/wijmo.angular2.grid.multirow/index.js",
"@mescius/wijmo.angular2.grid.sheet": "npm:@mescius/wijmo.angular2.grid.sheet/index.js",
'@mescius/wijmo.angular2.grid.transposed': 'npm:@mescius/wijmo.angular2.grid.transposed/index.js',
'@mescius/wijmo.angular2.grid.transposedmultirow': 'npm:@mescius/wijmo.angular2.grid.transposedmultirow/index.js',
"@mescius/wijmo.angular2.grid": "npm:@mescius/wijmo.angular2.grid/index.js",
"@mescius/wijmo.angular2.input": "npm:@mescius/wijmo.angular2.input/index.js",
"@mescius/wijmo.angular2.olap": "npm:@mescius/wijmo.angular2.olap/index.js",
"@mescius/wijmo.angular2.viewer": "npm:@mescius/wijmo.angular2.viewer/index.js",
"@mescius/wijmo.angular2.nav": "npm:@mescius/wijmo.angular2.nav/index.js",
"@mescius/wijmo.angular2.directivebase": "npm:@mescius/wijmo.angular2.directivebase/index.js",
'@mescius/wijmo.angular2.barcode.common': 'npm:@mescius/wijmo.angular2.barcode.common/index.js',
'@mescius/wijmo.angular2.barcode.composite': 'npm:@mescius/wijmo.angular2.barcode.composite/index.js',
'@mescius/wijmo.angular2.barcode.specialized': 'npm:@mescius/wijmo.angular2.barcode.specialized/index.js',
'bootstrap.css': 'npm:bootstrap/dist/css/bootstrap.min.css',
'jszip': 'https://cdnjs.cloudflare.com/ajax/libs/jszip/3.10.1/jszip.min.js',
'@angular/core': 'npm:@angular/core/fesm2022/core.mjs',
'@angular/core/primitives/signals': 'npm:@angular/core/fesm2022/primitives/signals.mjs',
'@angular/core/primitives/event-dispatch': 'npm:@angular/core/fesm2022/primitives/event-dispatch.mjs',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/http': 'npm:@angular/http/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
"./src": {
defaultExtension: 'ts'
},
"node_modules": {
defaultExtension: 'js'
},
wijmo: {
defaultExtension: 'js',
}
}
});
})(this);